<template>
  <div class="measurement-wrapper" :style="{'height':height+10+'px'}">

    <div class="container" :style="{'height':height+'px'}">
      <h3 v-if="isReadingShowSubjectInfo" style="color: #ddd;padding: 5px 0px;margin: 0;">
        <span v-if="subjectCode">{{ subjectCode }} </span>
        <span style="margin-left:5px;">{{ taskBlindName }}</span>
      </h3>
      <!-- 非测量问题 -->
      <div class="lesions">
        <Questions ref="ecrf" :question-form-change-state="questionFormChangeState" :question-form-change-num="questionFormChangeNum" />
      </div>
      <!-- 测量问题 -->
      <template v-if="questions.length > 0">
        <div v-for="(qs,index) in questions" :key="index" v-loading="loading" class="lesions lesions_wrapper">
          <h4 v-if="qs.Type === 'group'" style="color: #ddd;padding: 5px 0px;margin: 0;">
            {{ language==='en'?qs.GroupEnName:qs.GroupName }}
          </h4>
          <div class="lesion_list">
            <div v-for="item in qs.Childrens" v-show="!(isBaseLineTask && item.LesionType === 2)" :key="item.Id">
              <div v-if="item.Type === 'table'" class="flex-row" style="margin:3px 0;">
                <div class="title">{{ item.QuestionName }}</div>
                <div v-if="readingTaskState<2 && (isBaseLineTask || item.LesionType === 2)" class="add-icon" @click.prevent="handleAdd(item)">
                  <i class="el-icon-plus" />
                </div>
              </div>
              <el-collapse
                v-if="item.Type === 'table' && item.TableQuestions"
                v-model="activeName"
                accordion
                @change="handleCollapseChange"
              >
                <el-collapse-item
                  v-for="(q,i) in item.TableQuestions.Answers"
                  :key="`${item.Id}_${q.RowIndex}`"
                  :name="`${item.Id}_${q.RowIndex}`"
                  @contextmenu.prevent.native="collapseRightClick($event,q,item.Id,q.RowIndex)"
                >
                  <template slot="title">
                    <div style="width:300px;position: relative;" :style="{color:(activeName===item.Id+q.RowIndex?'#ffeb3b':'#fff')}">

                      {{ getLesionName(item.OrderMark,q.RowIndex) }}
                      <!-- 未保存 -->
                      <el-tooltip v-if="readingTaskState<2 && parseInt(item.TableQuestions.Answers[i].saveTypeEnum) === 0" class="item" effect="dark" :content="$t('trials:reading:button:unsaved')" placement="bottom">
                        <i class="el-icon-warning" style="color:red" />
                      </el-tooltip>
                      <!-- 信息不完整 -->
                      <el-tooltip v-if="readingTaskState<2 && parseInt(item.TableQuestions.Answers[i].saveTypeEnum) ===1" class="item" effect="dark" :content="$t('trials:reading:button:incompleteInfor')" placement="bottom">
                        <i class="el-icon-warning" style="color:#ff9800" />
                      </el-tooltip>
                      <div style="position: absolute;left: 50px;top: 2px;">
                        <div style="font-size: 11px;width:220px;height: 30px;">
                          <div
                            v-if="item.TableQuestions.Answers[i].lesionPart"
                            style="margin-left:10px;display: inline-block; white-space: nowrap;overflow: hidden;text-overflow: ellipsis;max-width:90px"
                          >
                            <el-tooltip v-if="!!item.TableQuestions.Answers[i].lesionPart" class="item" effect="dark" :content="item.TableQuestions.Answers[i].lesionPart" placement="bottom">
                              <span>{{ item.TableQuestions.Answers[i].lesionPart }}</span>
                            </el-tooltip>
                          </div>
                          <div style="display: inline-block;margin-left:5px;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;max-width:50px">
                            <span v-if="item.LesionType === 0">
                              {{ $fd('TargetState',parseInt(item.TableQuestions.Answers[i].lesionState)) }}
                            </span>
                            <span v-else-if="item.LesionType === 1">
                              {{ $fd('NoTargetState',parseInt(item.TableQuestions.Answers[i].lesionState)) }}
                            </span>
                            <span v-else>
                              {{ $fd('NewLesionState',parseInt(item.TableQuestions.Answers[i].lesionState)) }}
                            </span>
                          </div>
                          <div style="display: inline-block;margin-left:5px;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;max-width:60px">

                            <template v-if="!isNaN(parseInt(item.TableQuestions.Answers[i].lesionLength))">
                              {{ item.TableQuestions.Answers[i].lesionLength }}mm
                            </template>
                          </div>
                        </div>
                      </div>
                      <div v-if="((item.LesionType === 0 && parseInt(item.TableQuestions.Answers[i].lesionState) === 0) || (item.LesionType === 1 && [0,1].includes(parseInt(item.TableQuestions.Answers[i].lesionState))) || (item.LesionType === 2 && parseInt(item.TableQuestions.Answers[i].lesionState) === 0)) && item.TableQuestions.Answers[i].IsCurrentTaskAdd === 'False'" style="position: absolute;right: 5px;top: 2px;transform: rotateY(180deg);">
                        <!-- 分裂 -->
                        <el-tooltip v-show="readingTaskState<2 && !!item.TableQuestions.Answers[i].RowId && !isBaseLineTask && item.TableQuestions.Answers[i].isDicomReading !== false" class="item" :content="$t('trials:reading:button:split')" placement="left">
                          <i class="iconfont icon-24gl-split" style="color:#fff;font-size: 16px;" @click.stop="handleSplit(item.TableQuestions.Answers[i].RowId,item.Id)" />
                        </el-tooltip>
                      </div>

                    </div>

                  </template>
                  <QuestionForm
                    :ref="`${item.Id}_${q.RowIndex}`"
                    :questions="item.TableQuestions.Questions"
                    :answers="item.TableQuestions.Answers[i]"
                    :lesion-type="item.LesionType"
                    :order-mark="item.OrderMark"
                    :table-questions="tableQuestions"
                    :row-index="String(q.RowIndex)"
                    :question-name="item.QuestionName"
                    :parent-qs-id="item.Id"
                    :visit-task-id="visitTaskId"
                    :is-current-task="isCurrentTask"
                    :reading-task-state="readingTaskState"
                    :is-base-line-task="isBaseLineTask"
                    @getReadingQuestionAndAnswer="getReadingQuestionAndAnswer"
                    @determineExistsUnsavedLession="determineExistsUnsavedLession"
                    @resetQuestions="resetQuestions"
                    @close="close"
                  />
                </el-collapse-item>

              </el-collapse>
            </div>
          </div>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
import { splitLesion } from '@/api/trials'
import DicomEvent from './../DicomEvent'

import store from '@/store'
import { mapGetters } from 'vuex'
import Questions from './../Questions'
import QuestionForm from './QuestionForm'
export default {
  name: 'RecistBMQsList',
  components: {
    Questions,
    QuestionForm
  },
  props: {
    isShow: {
      type: Boolean,
      required: true
    },
    isReadingShowSubjectInfo: {
      type: Boolean,
      required: true
    },
    questionFormChangeState: {
      type: Boolean,
      default() {
        return false
      }
    },
    questionFormChangeNum: {
      type: Number,
      default() {
        return 0
      }
    }
  },
  data() {
    return {
      height: window.innerHeight - 140,
      questions: [],
      activeName: '',
      activeItem: {
        activeRowIndex: null,
        activeCollapseId: null
      },
      visitTaskId: '',
      isCurrentTask: false,
      loading: false,
      unSaveTargets: [],
      temporaryLesions: [],
      readingTaskState: 2,
      isBaseLineTask: false,
      taskBlindName: '',
      tableQuestions: [],
      isFirstRender: false,
      CriterionType: null,
      subjectCode: ''
    }
  },
  computed: {
    ...mapGetters(['visitTaskList', 'language', 'lastCanvasTaskId', 'currentReadingTaskState'])
  },
  watch: {
    lastCanvasTaskId: {
      immediate: true,
      handler(val) {
        if (val) {
          this.initList()
        }
      }
    },
    currentReadingTaskState: {
      immediate: true,
      handler(val) {
        if (val) {
          this.readingTaskState = val
        }
      }
    }
  },
  mounted() {
    this.subjectCode = this.$router.currentRoute.query.subjectCode
    window.addEventListener('message', this.receiveMsg)
    this.CriterionType = parseInt(localStorage.getItem('CriterionType'))
    DicomEvent.$on('setCollapseActive', measureData => {
      this.setCollapseActive(measureData)
      console.log('setCollapseActive')
    })
    DicomEvent.$on('changeLesionType', (questionsObj) => {
      this.changeLesionType(questionsObj)
      console.log('changeLesionType')
    })
    DicomEvent.$on('getAllUnSaveLesions', (callback) => {
      var list = this.getAllUnSaveLesions()
      callback(list)
      console.log('getAllUnSaveLesions')
    })

    DicomEvent.$on('split', measureData => {
      this.handleSplit(measureData.RowId, measureData.QuestionId)
    })

    window.addEventListener('resize', this.setHeight)
  },
  beforeDestroy() {
    DicomEvent.$off('loadMeasurementList')
    DicomEvent.$off('setCollapseActive')
    DicomEvent.$off('changeLesionType')
    DicomEvent.$off('getUnSaveTarget')
    DicomEvent.$off('setReadingState')
  },
  methods: {
    async initList() {
      var i = this.visitTaskList.findIndex(i => i.VisitTaskId === this.lastCanvasTaskId)
      if (i > -1) {
        this.visitTaskId = this.visitTaskList[i].VisitTaskId
        this.taskBlindName = this.visitTaskList[i].TaskBlindName
        this.readingTaskState = this.visitTaskList[i].ReadingTaskState
        this.isBaseLineTask = this.visitTaskList[i].IsBaseLineTask
        this.isCurrentTask = this.visitTaskList[i].IsCurrentTask
        this.activeName = ''
        this.activeItem.activeRowIndex = null
        this.activeItem.activeCollapseId = null
        if (!this.visitTaskList[i].IsInit) {
          var loading = this.$loading({ fullscreen: true })
          var triald = this.trialId = this.$router.currentRoute.query.trialId
          if (!this.visitTaskList[i].measureDataInit) {
            await store.dispatch('reading/getMeasuredData', this.visitTaskList[i].VisitTaskId)
          }
          if (!this.visitTaskList[i].studyListInit) {
            await store.dispatch('reading/getStudyInfo', { trialId: triald, subjectVisitId: this.visitTaskList[i].VisitId, visitTaskId: this.visitTaskList[i].VisitTaskId, taskBlindName: this.visitTaskList[i].TaskBlindName })
          }
          if (!this.visitTaskList[i].readingQuestionsInit) {
            await store.dispatch('reading/getReadingQuestionAndAnswer', { trialId: triald, visitTaskId: this.visitTaskList[i].VisitTaskId })
          }
          if (!this.visitTaskList[i].questionsInit) {
            await store.dispatch('reading/getDicomReadingQuestionAnswer', { trialId: triald, visitTaskId: this.visitTaskList[i].VisitTaskId })
          }

          await store.dispatch('reading/setStatus', { visitTaskId: this.visitTaskList[i].VisitTaskId })
          loading.close()
        }
        this.questions = this.visitTaskList[i].ReadingQuestions
        this.$nextTick(() => {
          this.$refs['ecrf'].getQuestions(this.visitTaskId)
          this.getTableQuestions()
          this.tableQuestions.forEach(item => {
            item.TableQuestions.Answers.forEach(i => {
              var refName = `${item.Id}_${i.RowIndex}`
              this.$refs[refName] && this.$refs[refName][0].initForm()
            })
          })
        })
      }
    },
    async resetQuestions(obj) {
      this.setQuestions(this.questions, obj)
      await store.dispatch('reading/setReadingQuestionAndAnswer', { questions: this.questions, visitTaskId: this.visitTaskId })

      this.getTableQuestions()
    },
    setQuestions(questions, obj) {
      questions.forEach(item => {
        if (item.Type === 'table' && item.Id === obj.questionId) {
          var idx = item.TableQuestions.Answers.findIndex(i => i.RowIndex === obj.rowIndex)
          item.TableQuestions.Answers[idx].isLymphLesion = 0
          item.TableQuestions.Answers[idx].loctation = obj.lesionOrgan
          item.TableQuestions.Answers[idx].lesionPart = obj.lesionPart
          item.TableQuestions.Answers[idx].lesionLength = obj.lesionLength
          item.TableQuestions.Answers[idx].lesionState = obj.lesionState
          item.TableQuestions.Answers[idx].saveTypeEnum = obj.saveTypeEnum

          for (const i in obj.anwsers) {
            if (i === 'MeasureData' && obj.anwsers[i]) {
              item.TableQuestions.Answers[idx].InstanceId = obj.anwsers[i].instanceId
              item.TableQuestions.Answers[idx].SeriesId = obj.anwsers[i].seriesId
              item.TableQuestions.Answers[idx][i] = JSON.stringify(obj.anwsers[i])
              item.TableQuestions.Answers[idx].isDicomReading = !(obj.anwsers[i].IsDicomReading === false || obj.anwsers[i].IsDicomReading === 'False')
            } else {
              item.TableQuestions.Answers[idx][i] = String(obj.anwsers[i])
            }
          }
        }
        if (item.Childrens.length > 0) {
          this.setQuestions(item.Childrens, obj)
        }
      })
    },
    getQuestions(questions) {
      questions.forEach(item => {
        if (item.Type === 'table' && item.TableQuestions && item.TableQuestions.Answers.length > 0) {
          item.TableQuestions.Answers.forEach(answerObj => {
            this.$set(answerObj, 'isLymphLesion', 0)
            this.$set(answerObj, 'loctation', this.getQuestionAnswer(item.TableQuestions.Questions, 6, answerObj))
            this.$set(answerObj, 'lesionLength', this.getQuestionAnswer(item.TableQuestions.Questions, 0, answerObj))

            var lesionState = this.getQuestionAnswer(item.TableQuestions.Questions, 7, answerObj)
            lesionState = !isNaN(parseInt(lesionState)) ? parseInt(lesionState) : ''
            this.$set(answerObj, 'lesionState', lesionState)
            if (answerObj.RowId) {
              var idx = item.TableQuestions.Questions.findIndex(i => i.QuestionMark === 11)
              if (idx > -1) {
                var lesionNum = this.getQuestionAnswer(item.TableQuestions.Questions, 11, answerObj)
                lesionNum = !isNaN(parseInt(lesionNum)) ? parseInt(lesionNum) : ''
                this.$set(answerObj, 'saveTypeEnum', isNaN(parseInt(lesionNum)) ? 1 : 2)
              } else {
                this.$set(answerObj, 'saveTypeEnum', isNaN(parseInt(lesionState)) ? 1 : 2)
              }
            } else {
              this.$set(answerObj, 'saveTypeEnum', 0)
            }
          })
        }
        if (item.Childrens.length > 0) {
          this.getQuestions(item.Childrens)
        }
      })
      return questions
    },
    getTableQuestions() {
      this.tableQuestions = []
      this.questions.map(item => {
        if (item.Type === 'table') {
          this.tableQuestions.push(item)
        }
        if (item.Childrens.length > 0) {
          this.getTableQuestionsChild(item.Childrens)
        }
      })
    },
    getTableQuestionsChild(obj) {
      obj.map(item => {
        if (item.Type === 'table') {
          this.tableQuestions.push(item)
        }
        if (item.Childrens.length > 0) {
          this.getTableQuestionsChild(item.Childrens)
        }
      })
    },
    refreshReadingQuestionAndAnswer(type) {
      if (type === 0) {
        // 删除
        this.activeName = ''
        this.activeItem.activeRowIndex = null
        this.activeItem.activeCollapseId = null
      }

      this.getReadingQuestionAndAnswer(this.visitTaskId)
    },
    getReadingQuestionAndAnswer() {
      return new Promise(async resolve => {
        try {
          const loading = this.$loading({ fullscreen: true })
          await store.dispatch('reading/refreshReadingQuestionAndAnswer', { trialId: this.$router.currentRoute.query.trialId, visitTaskId: this.visitTaskId }).then(() => {
            var idx = this.visitTaskList.findIndex(i => i.VisitTaskId === this.visitTaskId)
            if (idx > -1) {
              if (this.visitTaskList[idx].ReadingQuestions.length > 0) {
                this.questions = this.visitTaskList[idx].ReadingQuestions
              }
              this.readingTaskState = this.visitTaskList[idx].ReadingTaskState
              this.isBaseLineTask = this.visitTaskList[idx].IsBaseLineTask
              this.isCurrentTask = this.visitTaskList[idx].IsCurrentTask
            }
            this.getTableQuestions()
            this.$nextTick(() => {
              this.tableQuestions.forEach(item => {
                item.TableQuestions.Answers.forEach(i => {
                  var refName = `${item.Id}_${i.RowIndex}`
                  this.$refs[refName] && this.$refs[refName][0].initForm()
                })
              })
            })
          })
          await store.dispatch('reading/refreshMeasuredData', this.visitTaskId)
          DicomEvent.$emit('getMeasureData')
          loading.close()
          resolve()
        } catch (e) { console.log(e) }
      })
    },
    setHeight() {
      this.height = window.innerHeight - 140
    },
    getQuestionAnswer(questions, questionMark, answers) {
      var idx = questions.findIndex(i => i.QuestionMark === questionMark)
      if (idx > -1) {
        var questionId = questions[idx].Id
        return answers[questionId]
      } else {
        return ''
      }
    },
    // 分裂
    handleSplit(rowId, questionId) {
      // 消失，无法评估，太小等状态病灶不支持分裂
      // 获取病灶状态
      var idx = this.tableQuestions.findIndex(i => i.Id === questionId)
      if (idx > -1) {
        var i = this.tableQuestions[idx].TableQuestions.Answers.findIndex(i => i.RowId === rowId)
        if (i > -1) {
          // var refName = `${questionId}_${this.tableQuestions[idx].TableQuestions.Answers[i].RowIndex}`
          // var lesionState = this.$refs[refName][0].getQuestionVal(7)
          // var lesionType = this.$refs[refName][0].lesionType
          // var isCurrentTaskAdd = this.tableQuestions[idx].TableQuestions.Answers[i].IsCurrentTaskAdd
          // if (isNaN(parseInt(lesionState))) {
          //   this.$confirm(`请先为病灶设置状态`, {
          //     type: 'warning',
          //     distinguishCancelAndClose: true
          //   })
          //     .then(() => {})
          //     .catch(() => {})
          // } else if (lesionType === 0 && lesionState !== 0) {
          //   // 靶病灶
          //   this.$confirm(`病灶状态为消失或无法评估或太小，不支持分裂`, {
          //     type: 'warning',
          //     distinguishCancelAndClose: true
          //   })
          //     .then(() => {})
          //     .catch(() => {})
          // } else if (lesionType === 1 && lesionState === 2 || lesionState === 3) {
          //   // 非靶病灶
          //   this.$confirm(`病灶状态为消失或无法评估，不支持分裂`, {
          //     type: 'warning',
          //     distinguishCancelAndClose: true
          //   })
          //     .then(() => {})
          //     .catch(() => {})
          // } else if (lesionType === 2 && (lesionState === 2 || lesionState === 3)) {
          //   // 新病灶
          //   this.$confirm(`病灶状态为消失或无法评估，不支持分裂`, {
          //     type: 'warning',
          //     distinguishCancelAndClose: true
          //   })
          //     .then(() => {})
          //     .catch(() => {})
          // } else if (isCurrentTaskAdd !== 'False') {
          //   this.$confirm(`首次添加的病灶不支持分裂`, {
          //     type: 'warning',
          //     distinguishCancelAndClose: true
          //   })
          //     .then(() => {})
          //     .catch(() => {})
          // } else {}
          var arr = []
          this.getUnSaveTarget()
          if (this.unSaveTargets.length > 0) {
            this.unSaveTargets.forEach(item => {
              arr.push(item.lessionName)
            })
          }
          var unSavedList = this.getAllUnSaveLesions()
          unSavedList.forEach(item => {
            arr.push(item.lessionName)
          })
          if (arr.length > 0) {
            // 病灶${message}，未保存。如果分裂，信息将被还原，是否继续？
            var msg = this.$t('trials:reading:warnning:msg3')
            msg = msg.replaceAll('xxx', arr.join('、'))
            this.$confirm(msg, {
              type: 'warning',
              distinguishCancelAndClose: true
            })
              .then(() => {
                this.split(rowId, questionId)
              })
              .catch(() => {})
          } else {
            // 是否确认分裂
            this.$confirm(this.$t('trials:reading:warnning:msg4'), {
              type: 'warning',
              distinguishCancelAndClose: true
            })
              .then(() => {
                this.split(rowId, questionId)
              })
              .catch(() => {})
          }
        }
      }
    },
    split(rowId, questionId) {
      const loading = this.$loading({ fullscreen: true })
      var params = {
        visitTaskId: this.visitTaskId,
        questionId: questionId,
        rowId: rowId
      }
      splitLesion(params).then(async res => {
        loading.close()
        await this.getReadingQuestionAndAnswer()
        this.$nextTick(() => {
          this.tableQuestions.forEach(item => {
            item.TableQuestions.Answers.forEach(i => {
              var refName = `${item.Id}_${i.RowIndex}`
              this.$refs[refName] && this.$refs[refName][0].initForm()
            })
          })
        })
      })
    },
    isCanActiveTool(toolName) {
      this.getUnSaveTarget()
      if (this.unSaveTargets.length > 0) {
        var rowIndex = String(this.unSaveTargets[0].rowIndex)
        var questionId = this.unSaveTargets[0].questionId
        const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        if (rowIndex === this.activeItem.activeRowIndex && questionId === this.activeItem.activeCollapseId && !this.$refs[refName][0].questionForm.MeasureData) {
          return this.checkToolCanActive(toolName)
        } else {
          var msg = this.$t('trials:reading:warnning:msg5')
          msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
          // `病灶${this.unSaveTargets[0].lessionName}信息未保存，不允许继续添加！`
          return { isCanActiveTool: false, reason: msg }
        }
      } else {
        if (this.activeItem.activeCollapseId) {
          return this.checkToolCanActive(toolName)
        } else {
          if (this.isBaseLineTask && (toolName === 'Length' || toolName === 'RectangleRoi')) {
            return { isCanActiveTool: true, reason: '' }
          } else if (!this.isBaseLineTask && (toolName === 'ArrowAnnotate' || toolName === 'Length' || toolName === 'RectangleRoi')) {
            return { isCanActiveTool: true, reason: '' }
          } else if (this.isBaseLineTask && toolName === 'ArrowAnnotate') {
            return { isCanActiveTool: false, reason: this.$t('trials:reading:warnning:msg54') }
          } else {
            return { isCanActiveTool: false, reason: '' }
          }
        }
      }
    },

    checkToolCanActive(toolName) {
      const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      if (!this.$refs[refName][0].questionForm.MeasureData) {
        if (this.isBaseLineTask) {
          if (this.$refs[refName][0].lesionType === 0 && toolName !== 'Length') {
            // '请使用直径测量工具进行靶病灶的标记。'
            return { isCanActiveTool: false, reason: this.$t('trials:readingBM:warnning:msg01') }
          } else if (this.$refs[refName][0].lesionType === 1 && toolName !== 'Length' && toolName !== 'RectangleRoi') {
            // '请使用直径测量工具或矩形测量工具进行非靶病灶的标记。'
            return { isCanActiveTool: false, reason: this.$t('trials:readingBM:warnning:msg02') }
          } else if (toolName === 'ArrowAnnotate') {
            // 基线病灶不能使用箭头工具标记。
            return { isCanActiveTool: false, reason: this.$t('trials:reading:warnning:msg54') }
          } else {
            return { isCanActiveTool: true, reason: '' }
          }
        } else {
          if (this.$refs[refName][0].lesionType === 0 && toolName !== 'Length' && toolName !== 'ArrowAnnotate') {
            // 请使用直径测量工具或箭头工具进行靶病灶的标记。
            return { isCanActiveTool: false, reason: this.$t('trials:readingBM:warnning:msg03') }
          } if (this.$refs[refName][0].lesionType === 1 && toolName !== 'Length' && toolName !== 'ArrowAnnotate' && toolName !== 'RectangleRoi') {
            // 请使用直径测量工具或矩形测量工具或箭头工具进行非靶病灶的标记。
            return { isCanActiveTool: false, reason: this.$t('trials:readingBM:warnning:msg04') }
          } else if (this.$refs[refName][0].lesionType === 2 && toolName !== 'Length' && toolName !== 'ArrowAnnotate') {
            // 请使用直径测量工具或箭头工具进行新病灶的标记。
            return { isCanActiveTool: false, reason: this.$t('trials:readingBM:warnning:msg05') }
          } else {
            return { isCanActiveTool: true, reason: '' }
          }
        }
      } else {
        return { isCanActiveTool: true, reason: '' }
      }
    },

    async handleAdd(qs) {
      // 判断是否有未保存的病灶
      this.getUnSaveTarget()
      if (this.unSaveTargets.length > 0) {
        // 病灶${this.unSaveTargets[0].lessionName}信息未保存，不允许继续添加！
        let msg = this.$t('trials:reading:warnning:msg5')
        msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)

        this.$confirm(msg, {
          type: 'warning',
          showCancelButton: false,
          callback: action => {}
        })
        return
      }
      if (!!qs.MaxQuestionCount && qs.MaxQuestionCount <= qs.TableQuestions.Answers.length) {
        let msg = this.$t('trials:reading:warnning:msg14')
        msg = msg.replace('xxx', qs.MaxQuestionCount)
        this.$confirm(msg, {
          type: 'warning',
          showCancelButton: false,
          callback: action => {}
        })
      } else {
        var obj = { saveTypeEnum: 0 }
        var maxIndex = this.getMaxRowIndex(qs.TableQuestions.Answers)
        obj.RowIndex = `${maxIndex + 1}.00`
        obj.IsDicomReading = true
        await store.dispatch('reading/addReadingQuestionAndAnswer', { lesionType: qs.LesionType, visitTaskId: this.visitTaskId, lesionObj: obj })

        this.activeItem.activeRowIndex = String(obj.RowIndex)
        this.activeItem.activeCollapseId = qs.Id
        this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      }
    },
    getMaxRowIndex(answerList) {
      if (answerList.length > 0) {
        var arr = []
        answerList.forEach(item => {
          var rowIndex = item.RowIndex
          arr.push(parseInt(rowIndex))
        })
        var max = Math.max.apply(null, arr)
        return max
      } else {
        return 0
      }
    },
    determineExistsUnsavedLession(callback) {
      this.getUnSaveTarget()
      if (this.unSaveTargets.length > 0) {
        var rowIndex = String(this.unSaveTargets[0].rowIndex)
        var questionId = this.unSaveTargets[0].questionId
        if (rowIndex === String(this.activeItem.activeRowIndex) && questionId === this.activeItem.activeCollapseId) {
          callback(true)
          return
        } else {
          // 病灶${this.unSaveTargets[0].lessionName}信息未保存，不允许执行此操作！
          let msg = this.$t('trials:reading:warnning:msg17')
          msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
          this.$confirm(msg, {
            type: 'warning',
            showCancelButton: false,
            callback: action => { }
          })
          callback(false)
          // loading.close()
          return
        }
      }
      callback(true)
      // loading.close()
      return
    },
    getUnSaveTarget() {
      this.unSaveTargets = []
      this.tableQuestions.map(item => {
        if (item.TableQuestions && item.TableQuestions.Answers) {
          item.TableQuestions.Answers.map(t => {
            if (!t.RowId) {
              var lessionName = this.getLesionName(item.OrderMark, t.RowIndex)
              this.unSaveTargets.push({ lessionName: lessionName, rowIndex: t.RowIndex, questionId: item.Id })
            }
          })
        }
      })
      return this.unSaveTargets
    },
    getAllUnSaveLesions() {
      var arr = []
      this.tableQuestions.map(item => {
        if (item.TableQuestions && item.TableQuestions.Answers) {
          item.TableQuestions.Answers.map(t => {
            const refName = `${item.Id}_${t.RowIndex}`
            if (this.$refs[refName] && this.$refs[refName][0] && this.$refs[refName][0].questionForm.saveTypeEnum !== 2) {
              var lessionName = this.getLesionName(item.OrderMark, t.RowIndex)
              arr.push({ lessionName: lessionName, rowIndex: t.RowIndex, questionId: item.Id })
            }
          })
        }
      })
      return arr
    },
    getLesionName(orderMark, rowIndex) {
      var lessionName = ''
      var rowIndexArr = rowIndex.split('.')
      var x = parseInt(rowIndexArr[0])
      var y = parseInt(rowIndexArr[1])
      if (y > 0) {
        y = String.fromCharCode(parseInt(rowIndexArr[1]) - 1 + 65 + 32)
        lessionName = `${orderMark}${String(x).padStart(2, '0')}${y}`
      } else {
        lessionName = `${orderMark}${String(x).padStart(2, '0')}`
      }

      return lessionName
    },
    handleCollapseChange(val) {
      if (this.activeName) {
        var arr = this.activeName.split('_')
        this.activeItem.activeRowIndex = arr[1]
        this.activeItem.activeCollapseId = arr[0]
        this.$nextTick(() => {
          const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
          if (this.$refs[refName][0].questionForm.IsDicomReading !== false) {
            var markTool = this.$refs[refName][0].currentMarkTool
            var readingTaskState = this.readingTaskState
            var isMarked = !!this.$refs[refName][0].questionForm.MeasureData
            DicomEvent.$emit('imageLocation', { questionId: this.activeItem.activeCollapseId, rowIndex: this.activeItem.activeRowIndex, visitTaskId: this.visitTaskId, lesionName: this.$refs[refName][0].lesionMark, lesionType: this.$refs[refName][0].lesionType, markTool, readingTaskState, isMarked })
          }
        })
      } else {
        this.activeItem.activeRowIndex = null
        this.activeItem.activeCollapseId = null
      }
    },
    collapseRightClick(e, obj, activeCollapseId, activeRowIndex) {
      if (obj.IsDicomReading !== false) {
        const refName = `${activeCollapseId}_${activeRowIndex}`
        DicomEvent.$emit('imageLocation', { questionId: activeCollapseId, rowIndex: activeRowIndex, visitTaskId: this.visitTaskId, lesionName: this.$refs[refName][0].lesionMark, lesionType: this.$refs[refName][0].lesionType })
      }
      e.stopImmediatePropagation()
      e.stopPropagation()
      e.preventDefault()
    },
    // 更改病灶类型
    async changeLesionType(questionsObj) {
      await store.dispatch('reading/removeReadingQuestionAndAnswer', { lesionType: questionsObj.oldLesionType, rowIndex: questionsObj.rowIndex, visitTaskId: this.visitTaskId })
      // saveTypeEnum: 0
      var lesionObj = { }
      var questionObj = questionsObj.questionForm
      // 切换到新的病灶集合
      var targetObj = this.tableQuestions.find(item => item.LesionType === questionsObj.newLesionType)
      var lesionMark = ''
      var maxIndex = this.getMaxRowIndex(targetObj.TableQuestions.Answers)
      lesionObj.RowIndex = `${maxIndex + 1}.00`
      lesionMark = `${targetObj.OrderMark}${String(maxIndex + 1).padStart(2, '0')}`
      targetObj.TableQuestions.Questions.forEach(i => {
        var obj = questionObj.find(v => v.QuestionMark === i.QuestionMark)
        if (obj) {
          lesionObj[i.Id] = obj.Answer
        }
      })

      if (questionsObj.measureData) {
        await store.dispatch('reading/removeMeasuredData', { visitTaskId: this.visitTaskId, measureData: questionsObj.measureData, questionId: questionsObj.questionId, rowIndex: questionsObj.rowIndex })

        questionsObj.measureData.data.remark = lesionMark
        lesionObj.MeasureData = JSON.stringify(questionsObj.measureData)
      }

      var deleteInfo = null
      if (questionsObj.rowId) {
        deleteInfo = { rowId: questionsObj.rowId, questionId: questionsObj.questionId }
      }
      await store.dispatch('reading/addReadingQuestionAndAnswer', { lesionType: questionsObj.newLesionType, visitTaskId: this.visitTaskId, lesionObj: lesionObj })

      this.activeItem.activeRowIndex = String(lesionObj.RowIndex)
      this.activeItem.activeCollapseId = targetObj.Id
      this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      this.$nextTick(() => {
        if (deleteInfo) {
          this.$refs[refName][0].setDeleteInfo(deleteInfo)
        }
        this.$refs[refName][0].setMeasureData(questionsObj.measureData, deleteInfo)
      })
    },
    removeQuestionAnswer(questionsObj) {
      // 移除当前病灶
      var currentObj = this.tableQuestions.find(item => item.LesionType === questionsObj.oldLesionType)
      if (currentObj) {
        var i = currentObj.TableQuestions.Answers.findIndex(i => String(i.RowIndex) === String(questionsObj.rowIndex))
        if (i === -1) return
        currentObj.TableQuestions.Answers.splice(i, 1)
      }
    },
    // 创建新病灶
    createNLTarget(measureData) {
      var idx = this.tableQuestions.findIndex(item => item.LesionType === 2)
      if (idx > -1) {
        this.addTarget(this.tableQuestions[idx], measureData)
      }
    },
    // 创建靶病灶
    createTTarget(measureData) {
      var idx = this.tableQuestions.findIndex(item => item.LesionType === 0)
      if (idx > -1) {
        this.addTarget(this.tableQuestions[idx], measureData)
      }
    },

    async addTarget(target, measureData) {
      // saveTypeEnum: 0
      var obj = {}
      var maxIndex = this.getMaxRowIndex(target.TableQuestions.Answers)
      obj.RowIndex = `${maxIndex + 1}.00`
      obj.IsDicomReading = !(measureData.isDicomReading === false || measureData.isDicomReading === 'False')
      obj.measureObj = measureData
      await store.dispatch('reading/addReadingQuestionAndAnswer', { lesionType: target.LesionType, visitTaskId: this.visitTaskId, lesionObj: obj })

      this.activeItem.activeRowIndex = String(obj.RowIndex)
      this.activeItem.activeCollapseId = target.Id
      this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
    },
    createNTTarget(measureData) {
      var idx = this.tableQuestions.findIndex(item => item.LesionType === 1)
      if (idx > -1) {
        this.addTarget(this.tableQuestions[idx], measureData)
      }
    },
    setCollapseActive(measureData) {
      if (measureData) {
        if (this.activeItem.activeRowIndex === measureData.RowIndex && this.activeItem.activeCollapseId === measureData.QuestionId) {
          return
        } else {
          this.activeItem.activeCollapseId = measureData.QuestionId
          this.activeItem.activeRowIndex = measureData.RowIndex
          this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        }
      }
    },
    modifyMeasuredData(measureObj) {
      if (measureObj.questionInfo) {
        this.activeItem.activeCollapseId = measureObj.questionInfo.QuestionId
        this.activeItem.activeRowIndex = String(measureObj.questionInfo.RowIndex)
        this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        this.$refs[refName][0].setMeasureData(measureObj.measureData)
      }
    },
    // 设置测量数据
    setMeasuredData(measureData) {
      if (this.activeItem.activeCollapseId) {
        // 判断是否存在测量数据
        this.$nextTick(() => {
          const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
          if ((this.$refs[refName][0].questionForm && this.$refs[refName][0].questionForm.MeasureData && measureData.data.uuid === this.$refs[refName][0].questionForm.MeasureData.data.uuid) || !this.$refs[refName][0].questionForm.MeasureData) {
            this.$refs[refName][0].setMeasureData(measureData)
          } else {
            if (this.isBaseLineTask) {
              var idx = this.tableQuestions.findIndex(item => item.LesionType === 0)
              if (this.tableQuestions[idx].TableQuestions.Answers.length < this.tableQuestions[idx].MaxQuestionCount && (measureData.type === 'Length')) {
                this.createTTarget(measureData)
              } else {
                this.createNTTarget(measureData)
              }
            } else {
              this.createNLTarget(measureData)
            }
          }
        })
      } else {
        if (this.isBaseLineTask) {
          var idx = this.tableQuestions.findIndex(item => item.LesionType === 0)
          if (this.tableQuestions[idx].TableQuestions.Answers.length < this.tableQuestions[idx].MaxQuestionCount && (measureData.type === 'Length' || measureData.type === 'Bidirectional')) {
            this.createTTarget(measureData)
          } else {
            this.createNTTarget(measureData)
          }
        } else {
          this.createNLTarget(measureData)
        }
      }
    },
    async close(questionsObj) {
      if (questionsObj) {
        this.getReadingQuestionAndAnswer(questionsObj.visitTaskId)
      }
      this.activeItem.activeRowIndex = null
      this.activeItem.activeCollapseId = null
      this.activeName = ''
    },
    getECRFQuestions(obj) {
      this.$refs['ecrf'].getQuestions(obj.visitTaskId)
    },
    receiveMsg(event) {
      if (event.data.type === 'isCanActiveNoneDicomTool') {
        this.getUnSaveTarget()
        var obj = {}
        if (this.unSaveTargets.length > 0) {
          var rowIndex = String(this.unSaveTargets[0].rowIndex)
          var questionId = this.unSaveTargets[0].questionId
          const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
          if (rowIndex === this.activeItem.activeRowIndex && questionId === this.activeItem.activeCollapseId && !this.$refs[refName][0].questionForm.MeasureData) {
            // 判断是否是靶病灶
            //  questions.findIndex(i => i.QuestionMark === questionMark)
            var lesionType = this.$refs[refName][0].questionForm.LesionType
            if (lesionType === 0) {
              // '当前病灶为靶病灶，不允许添加标记！'
              obj = { isCanActiveTool: false, lesionName: '', reason: this.$t('trials:reading:warnning:msg18') }
            } else {
              obj = { isCanActiveTool: true, lesionName: this.$refs[refName][0].lesionMark, reason: '', toolName: event.data.toolName }
            }
          } else {
            let msg = this.$t('trials:reading:warnning:msg5')
            msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
            obj = { isCanActiveTool: false, lesionName: '', reason: msg }
          }
        } else {
          if (this.activeItem.activeCollapseId) {
            // 判断是否是靶病灶
            const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
            const lesionType = this.$refs[refName][0].questionForm.LesionType
            if (lesionType === 0) {
              // 当前病灶为靶病灶，不允许添加标记！
              obj = { isCanActiveTool: false, lesionName: '', reason: this.$t('trials:reading:warnning:msg18') }
            } else {
              obj = { isCanActiveTool: true, lesionName: this.$refs[refName][0].lesionMark, reason: '', toolName: event.data.toolName }
            }
          } else {
            // 获取非靶病灶/新病灶的长度及标识
            var qsObj = null
            var lesionName = ''
            if (this.isBaseLineTask) {
              const idx = this.tableQuestions.findIndex(item => item.LesionType === 1)
              if (idx > -1) {
                qsObj = this.tableQuestions[idx]
              }
            } else {
              const idx = this.tableQuestions.findIndex(item => item.LesionType === 2)
              if (idx > -1) {
                qsObj = this.tableQuestions[idx]
              }
            }
            var maxIndex = this.getMaxRowIndex(qsObj.TableQuestions.Answers)
            lesionName = `${qsObj.OrderMark}${String(maxIndex + 1).padStart(2, '0')}`
            obj = { isCanActiveTool: true, lesionName: lesionName, reason: '', toolName: event.data.toolName }
          }
        }

        DicomEvent.$emit('isCanActiveNoneDicomTool', obj)
      } else if (event.data.type === 'setMeasurement') {
        this.setMeasuredData(event.data.data)
      }
    }

  }
}
</script>
<style lang="scss" scoped>
.measurement-wrapper{
  overflow-y: auto;
  // overflow: hidden;

  .container{
    padding: 10px;
  }
  .title{
    padding: 5px;
    font-weight: bold;
    color: #ddd;
    font-size: 15px;

  }
  .add-icon{
    padding: 5px;
    font-weight: bold;
    color: #ddd;
    font-size: 15px;
    border: 1px solid #938b8b;
    margin-bottom: 2px;
    cursor: pointer;
  }
  .add-icon:hover{
    background-color: #607d8b;
  }

  .flex-row{
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    background-color: #424242;

  }
  .lesion_list{
    position: relative;
  }
  .el-collapse{
    border-bottom:none;
    border-top:none;
    /deep/ .el-collapse-item{
      background-color: #000!important;
      color: #ddd;

    }
    /deep/ .el-collapse-item__header{
      background-color: #000!important;
      color: #ddd;
      border-bottom-color:#5a5a5a;
      padding-left: 5px;
      height: 35px;
      line-height: 35px;
    }
    /deep/ .el-collapse-item__wrap{
      background-color: #000!important;
      color: #ddd;
    }
    /deep/ .el-collapse-item__content{
      width:260px;
      position: absolute;
      top: 0px;
      right: 0px;
      // border: 1px solid #ffeb3b;
      border: 1px solid #fff;
      z-index: 1;
      color: #ddd;
      padding: 5px;
      background-color:#1e1e1e;
    }

  }
}
</style>
